unit Main;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls, StdActns,
  ActnList, ToolWin, ImgList,

  // TMDISaveIt units
  GenericSave, MDISaveIt;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileCloseItem: TMenuItem;
    Window1: TMenuItem;
    Help1: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    HelpAboutItem: TMenuItem;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    Edit1: TMenuItem;
    CutItem: TMenuItem;
    CopyItem: TMenuItem;
    PasteItem: TMenuItem;
    WindowMinimizeItem: TMenuItem;
    StatusBar: TStatusBar;
    ActionList1: TActionList;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    FileNew1: TAction;
    FileSave1: TAction;
    FileExit1: TAction;
    FileOpen1: TAction;
    FileSaveAs1: TAction;
    WindowCascade1: TWindowCascade;
    WindowTileHorizontal1: TWindowTileHorizontal;
    WindowArrangeAll1: TWindowArrange;
    WindowMinimizeAll1: TWindowMinimizeAll;
    HelpAbout1: TAction;
    FileClose1: TWindowClose;
    WindowTileVertical1: TWindowTileVertical;
    WindowTileItem2: TMenuItem;
    ToolBar2: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton9: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ImageList1: TImageList;
    MDISaveIt: TMDISaveIt;
    MDISaveItType1: TMDISaveItType;
    N2: TMenuItem;
    N3: TMenuItem;
    FileCloseAllItem: TMenuItem;
    FileCloseAll1: TAction;
    procedure HelpAbout1Execute(Sender: TObject);
    procedure FileExit1Execute(Sender: TObject);
    procedure MDISaveItAllowClose(Sender: TObject; Allowed: Boolean);
    procedure MDISaveItAllowSave(Sender: TObject; Allowed: Boolean);
    procedure MDISaveItAllowSaveAs(Sender: TObject; Allowed: Boolean);
    procedure FileNew1Execute(Sender: TObject);
    procedure FileOpen1Execute(Sender: TObject);
    procedure FileSave1Execute(Sender: TObject);
    procedure FileSaveAs1Execute(Sender: TObject);
    procedure FileClose1Execute(Sender: TObject);
    procedure FileCloseAll1Execute(Sender: TObject);
    procedure MDISaveItType1FileNew(Sender: TObject; var Proceed: Boolean;
      var NewChild: TForm);
    procedure ToolButton9Click(Sender: TObject);
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses ChildWin, About;

procedure TMainForm.HelpAbout1Execute(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TMainForm.FileExit1Execute(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.MDISaveItAllowClose(Sender: TObject; Allowed: Boolean);
begin
  FileClose1.Enabled    := Allowed;
  FileCloseAll1.Enabled := Allowed;
end;

procedure TMainForm.MDISaveItAllowSave(Sender: TObject; Allowed: Boolean);
begin
  FileSave1.Enabled := Allowed;
end;

procedure TMainForm.MDISaveItAllowSaveAs(Sender: TObject;
  Allowed: Boolean);
begin
  FileSaveAs1.Enabled := Allowed;
end;

procedure TMainForm.FileNew1Execute(Sender: TObject);
begin
  MDISaveIt.New;

end;

procedure TMainForm.FileOpen1Execute(Sender: TObject);
begin
  MDISaveIt.Open;
end;

procedure TMainForm.FileSave1Execute(Sender: TObject);
begin
  MDISaveIt.Save;
end;

procedure TMainForm.FileSaveAs1Execute(Sender: TObject);
begin
  MDISaveIt.SaveAs;
end;

procedure TMainForm.FileClose1Execute(Sender: TObject);
begin
  MDISaveIt.Close;
end;

procedure TMainForm.FileCloseAll1Execute(Sender: TObject);
begin
  MDISaveIt.CloseAll;
end;

procedure TMainForm.MDISaveItType1FileNew(Sender: TObject;
  var Proceed: Boolean; var NewChild: TForm);
begin
  { create a new MDI child window }
  NewChild := TMDIChild.Create(Application);

{ Example: How to display a dialog (or anything else requiring user input)
           within this Event. It is necessary to do it this way because
           user-input is this event is disabled for the entire application.
  -----------------------------------------------------------------------
  Note: This is only necessary for OnFileNew, do not use EnableApp or
        DisableApp in the OnFileOpen Event! So If you're going to use
        EnableApp/DisableApp please make sure TMDISaveItType.OnFileOpen
        does not point to the OnFileNew event handler (as is the default
        case with this template)
  -----------------------------------------------------------------------

  with MDIChildSaveIt1.MDISaveIt do
  try
    EnableApp;
    ShowMessage('This is my dialog.');
  finally
    DisableApp; // Important, don't forget!
  end;
}
end;

procedure TMainForm.ToolButton9Click(Sender: TObject);
begin
  // Create New File of Default Type
  MDISaveIt.NewDefault;
end;

end.
